@echo off
setlocal

REM ****10/21 ADD****************************
set isSilent=0

:loop
set subcom=%1

if "%subcom%" equ "" goto Install

if %subcom:~0,1% neq - (
	shift
	goto loop
)

if "%subcom:~1%" equ "" (
	shift
	goto loop
)

REM *** Silent Install Command "-S"***********
if /i %subcom:~1% equ s ( set isSilent=1 ) else (
	shift
	goto loop
)

REM ****10/21 ADD end****************************
:Install

REM //////////////////////////////////////////////////////
REM     Copyright (C) 2010 NEC Corporation.
REM     All rights reserved.
REM //////////////////////////////////////////////////////
set VER=2.1.0824.2010

echo NEC Express5800/320F series - Calendar Reviser
echo Setup command Version %VER%
echo Copyright (C) 2010 NEC Corporation.  All rights reserved.
echo.


pushd "%~dp0"
set EXIT_CODE=0


REM **************************************************
REM {ob`̃[JRoot肵ZbgAbv
REM ΏDirݒB
REM
REM **************************************************
:INIT
	REM ======================================
	REM CABt@C̏ by EXP-Builder
	REM EDOS8.3`
	REM E啶̂
	REM ======================================
	set SETUPCAB=SETUP.CAB
	set COMPNAME=CalRev
	set COREFILE=CalRev.wsf

	REM ===================================================
	REM `ς݊ϐ̃NI[gt
	REM
	REM %SystemRoot%̕񂪃Ot@C̏ꍇl
	REM jSystemRoot̂̂㏑ݒ肵Ă܂
	REM     schtasksR}hŁuNXo^ĂȂv
	REM     G[Ă܂B
	REM ===================================================
	set MySystemRoot=%SystemRoot%
	echo %MySystemRoot%|findstr "^\".*\"$" > nul && goto PATH_QUOTED
	set MySystemRoot="%MySystemRoot%"

:PATH_QUOTED
	set GPDIR=%MySystemRoot%\System32\GroupPolicy
	set SETUPDIR=%GPDIR%\Machine\Scripts\Shutdown
	set TASKSDIR=%MySystemRoot%\Tasks
	set SCRIPTDIR=%GPDIR%\Machine\Scripts
	set REGDIR=%GPDIR%\Machine
	set RTCDIR=%Programfiles%\NEC\HAS_SW\RTC
	set SCRIPTBK=%RTCDIR%\Script_BK
	set REGBK=%RTCDIR%\Registry_BK
	set GPTBK=%RTCDIR%\GPT_BK

REM **************************************************
REM START
REM **************************************************
:START

	echo.
	echo "Setup starts."
	echo.

	if not exist %SETUPDIR% mkdir %SETUPDIR%
	if not exist %SETUPDIR% (
		call :E_NOT_FOUND %SETUPDIR%
		goto END
	)
	attrib +h %GPDIR%

	if not exist %TASKSDIR% (
		call :E_NOT_FOUND %TASKSDIR%
		goto END
	)
	
	if not exist %SETUPDIR%\%COREFILE% (
		call :SETUPLOG create Start "Create new RTCSetup.log."
	)

	if not exist "%SCRIPTBK%" mkdir "%SCRIPTBK%"
	if not exist "%SCRIPTBK%" (
		call :E_NOT_FOUND "%SCRIPTBK%"
		goto End
	)

	if not exist "%REGBK%" mkdir "%REGBK%"
	if not exist "%REGBK%" (
		call :E_NOT_FOUND "%REGBK%"
		goto End
	)

	if not exist "%GPTBK%" mkdir "%GPTBK%"
	if not exist "%GPTBK%" (
		call :E_NOT_FOUND "%GPTBK%"
		goto End
	)

REM ***************************************************
REM 2010/08/16 Add T[rX̐ݒύX
REM ***************************************************
:SERVCONF

	set SCHEDULENAME=schedule
	set WINMGMTNAME=winmgmt
	set COUNT=0

	call :SERCHK

	if %COUNT% EQU 0 goto SHUTDOWN

	echo For this Calendar revise patch to operate properly, following two servises
        echo need to be turned on.
	echo      -Task Scheduler
	echo      -Windows Management Instrumentation
	set /p choice=Do you proceed to turn on these services now? [Y/N]:
	if '%choice%'=='' (
		call :E_SERVCONF
		goto End
	)
	if not '%choice%'=='' set choice=%choice:~0,1%
	
	if /i %choice% NEQ y (
		call :E_SERVCONF
		goto End
	)

	REM Task Scheduler START_TYPE
	if %COUNT% GEQ 16 (
		sc config %SCHEDULENAME% start= AUTO
		set /a COUNT=%COUNT% - 16
	)

	REM Task Scheduler STATE
	if %COUNT% GEQ 8 (
		if %IsSCHRUN% equ 1 net start %SCHEDULENAME%
		if %IsSCHRUN% equ 7 net continue %SCHEDULENAME%
		set /a COUNT=%COUNT% - 8
	)

	REM Windows Management START_TYPE
	if %COUNT% GEQ 4 (
		sc config %WINMGMTNAME% start= AUTO
		set /a COUNT=%COUNT% - 4
	)

	if %COUNT% GEQ 2 (
		net continue %WINMGMTNAME%
		set /a COUNT=%COUNT% - 2
	)

	set COUNT=0
	set IsSCHRUN=
	set IsSCHSTART=
	set IsWINMGSTART=
	set IsWINPAUSED=
	call :SERCHK

	if %COUNT% GTR 0 call :E_SERCHK

REM ***************************************************
REM 2010/08/16 Add Vbg_EXNvg̓o^
REM ***************************************************
:SHUTDOWN

	for /F %%a in ('tasklist /fi "imagename eq mmc.exe"') do (
		if "%%a" equ "mmc.exe" set image=%%a
	)
	if defined image (
		call :E_GPOEDIT
		goto END
	)

REM ********** p[^l̎Z **********
	set ADDPARAM=600
	set TIMEOUT=0

	for /F "delims== tokens=1,2" %%a in ('type %SystemDrive%\Boot.ini') do (
		if %%a equ timeout (
			set TIMEOUT=%%b
		)
	)

	set /a Parameter=%TIMEOUT%+%ADDPARAM%

	set SCRIPTSINI=scripts.ini
	set SCDUMMY=t_scripts.ini

	set REGPOL=Registry.pol
	set REGDUMMY=c_Registry.pol

	set GPTDUMMY=t_gpt.ini
	set GPT=gpt.ini

REM ********** obNAbv **********
:backup

	set HOUR=%TIME:~0,2%
	set MINUTE=%TIME:~3,2%
	set SECOND=%TIME:~6,2%
	set backupdate=%DATE:~0,4%%DATE:~5,2%%DATE:~8,2%_%HOUR%%MINUTE%%SECOND%

	if not exist "%RTCDIR%" mkdir "%RTCDIR%" >nul

	if exist %SCRIPTDIR%\%SCRIPTSINI% (
		attrib -h %SCRIPTDIR%\%SCRIPTSINI%
		copy %SCRIPTDIR%\%SCRIPTSINI% "%SCRIPTBK%\%SCRIPTSINI%_%backupdate%.BAK" >nul
		attrib +h %SCRIPTDIR%\%SCRIPTSINI%
		call :SETUPLOG add Backup "%SCRIPTBK%\%SCRIPTSINI% was backup > %SCRIPTBK%\%SCRIPTSINI%_%backupdate%.BAK"
	)
	if exist %REGDIR%\%REGPOL% (
		copy %REGDIR%\%REGPOL% "%REGBK%\%REGPOL%_%backupdate%.BAK" >nul
		call :SETUPLOG add Backup "%REGBK%\%REGPOL% was backup. > %REGBK%\%REGPOL%_%backupdate%.BAK"
	)
	if exist %GPDIR%\%GPT% (
		copy %GPDIR%\%GPT% "%GPTBK%\%GPT%_%backupdate%.BAK" >nul
		call :SETUPLOG add Backup "%GPTBK%\%GPT% is backup. > %GPTBK%\%GPT%_%backupdate%.BAK"
	)

REM ********** Registry.pol̕ҏW **********
:Registry

	set Key=SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System
	set Value=MaxGPOScriptWait
	set /a Data=%Parameter%+60
	set iserror=0
	
	if exist %GPTDUMMY% del %GPTDUMMY% > nul
	if not exist %REGDIR%\%REGPOL% goto regcase_0

	for /F "delims=: " %%a in ('gpresult /scope computer /v ^| findstr /n /i %Key%\%Value%') do (
		set maxscriptwaitnum=%%a
	)

	if not defined maxscriptwaitnum goto regcase_1

	for /F "skip=%maxscriptwaitnum% tokens=2,3 delims=:, " %%a in ('gpresult /scope computer /v') do (
		set num_1=%%a
		set num_256=%%b
		goto getregvalue
	)

:getregvalue

	if %num_1:~0,1% GTR 256 goto regcase_2

	set /a cmpData=%num_256%*256
	set /a cmpData=%cmpData%+%num_1%

	if %cmpData% LSS %Data% goto regcase_2
	call :SETUPLOG add Registry "%Value% is already entried."
	goto scripts

:regcase_0
	call :EDIT_REGISTRY %Data%
	if %iserror% GTR 0 goto END
	call :SETUPLOG add Registry "Created new Registry.pol."
	goto scripts

:regcase_1
	call :EDIT_REGISTRY %Data%
	if %iserror% GTR 0 goto END
	call :SETUPLOG add Registry "Add new %Value% in Registry.pol."
	goto scripts

:regcase_2
	call :EDIT_REGISTRY %Data%
	if %iserror% GTR 0 goto END
	call :SETUPLOG add Registry "Entried %Value% was update."

REM ********** scripts.ini̕ҏW **********
:scripts
	if exist %SCDUMMY% del %SCDUMMY% > nul

	if Not exist %SCRIPTDIR%\%SCRIPTSINI% goto scripts_0

	attrib -h %SCRIPTDIR%\%SCRIPTSINI%

	for /F "delims=" %%a in ('type %SCRIPTDIR%\%SCRIPTSINI%') do echo %%a>>%SCDUMMY%
	copy %SCDUMMY% %SCRIPTDIR%\%SCRIPTSINI% > nul
	if exist %SCDUMMY% del %SCDUMMY% > nul

	for /F "delims=[] tokens=1,2" %%a in ('find /n "[Shutdown]" %SCRIPTDIR%\%SCRIPTSINI%') do (
		if "%%b" neq "" set shutdownidx=%%a
	)

	if not defined shutdownidx goto scripts_1

	set idx=1
:gettotalline
	for /F "skip=%idx%" %%a in ('type %SCRIPTDIR%\%SCRIPTSINI%') do (
		set /a idx=%idx%+1
		goto gettotalline
	)

	set line=%shutdownidx%
	set setidx=0

:setscnum
	if not defined cmpnum goto scnumchk

:loop_1
	if not defined cmpnum goto loopend_1
	if %cmpnum:~0,1% LEQ 9 (
		set tmpnum=%tmpnum%%cmpnum:~0,1%
		set cmpnum=%cmpnum:~1%
		goto loop_1
	)

:loopend_1
	set cmpnum=%tmpnum%
	set tmpnum=
	if %setidx% LEQ %cmpnum% set /a setidx=%cmpnum%+1

:scnumchk
	for /F "skip=%line% delims== tokens=1,*" %%a in ('type %SCRIPTDIR%\%SCRIPTSINI%') do (
		if /i "%%a" equ "[Startup]" ( goto getscnum ) else (
			set /a line=%line%+1
			set cmpnum=%%a
			goto setscnum
		)
	)

:getscnum
	for /F "delims=[] tokens=1,2" %%a in ('find /n /i "[Startup]" %SCRIPTDIR%\%SCRIPTSINI%') do (
		if "%%b" neq "" set startupidx=%%a
	)
	if not defined startupidx goto scripts_2chk

	for /F "tokens=1,2,3 delims=[] " %%a in ('find /n /i "CalRev.wsf" %SCRIPTDIR%\%SCRIPTSINI%') do (
		if /i "%%c" equ "//job:shutdown" (
		if %%a GTR %shutdownidx% (
			if %shutdownidx% GTR %startupidx% (
				call :GETSCRIPTNUM %%b
				attrib +h %SCRIPTDIR%\%SCRIPTSINI%
				goto grouppolicy
			)
			if %%a LSS %startupidx% (
				call :GETSCRIPTNUM %%b
				attrib +h %SCRIPTDIR%\%SCRIPTSINI%
				goto grouppolicy
			)
		)
		)
	)
	if %shutdownidx% LSS %startupidx% goto scripts_3
	goto scripts_2

:scripts_0
	echo [Shutdown]> %SCDUMMY%
	call :SCRIPTUPDATE 0 %Parameter%
	set setidx=0
	call :SETUPLOG add Scripts "Created new scripts.ini."
	goto Scriptcreate

:scripts_1
	type %SCRIPTDIR%\%SCRIPTSINI% > %SCDUMMY%
	echo [Shutdown]>> %SCDUMMY%
	call :SCRIPTUPDATE 0 %Parameter%
	set setidx=0
	call :SETUPLOG add Scripts "Created new Shutdown Group."
	goto Scriptcreate

:scripts_2chk
	for /F "tokens=1,2,3 delims=[] " %%a in ('find /n /i "CalRev.wsf" %SCRIPTDIR%\%SCRIPTSINI%') do (
		if /i "%%c" equ "//job:shutdown" set calrev=%%b %%c
	)
	if defined calrev (
		call :SETUPLOG add Scripts "CalRev.wsf is already entried in Shutdown Group."
		call :GETSCRIPTNUM %calrev%
		attrib +h %SCRIPTDIR%\%SCRIPTSINI%
		goto grouppolicy
	)

:scripts_2
	type %SCRIPTDIR%\%SCRIPTSINI% > %SCDUMMY%
	call :SCRIPTUPDATE %setidx% %Parameter%
	call :SETUPLOG add Scripts "Entried new CalRev.wsf in Shutdown Group."
	goto Scriptcreate

:scripts_3
	for /F "delims== tokens=1,*" %%a in ('type %SCRIPTDIR%\%SCRIPTSINI%') do (
		if "%%a" equ "[Startup]" (
			call :SCRIPTUPDATE %setidx% %Parameter%
		)
		if "%%b" neq "" (echo %%a=%%b>> %SCDUMMY%) else echo %%a>> %SCDUMMY%
	)
	call :SETUPLOG add Scripts "Entried new CalRev.wsf in Shutdown Group."

:Scriptcreate
	copy %SCDUMMY% %SCRIPTDIR%\%SCRIPTSINI% > nul
	attrib +h %SCRIPTDIR%\%SCRIPTSINI%
	del %SCDUMMY% > nul

REM ********** gpt.ini̕ҏW **********
:grouppolicy

	set ADDINFO1=[{42B5FAAE-6536-11D2-AE5A-0000F87571E3}{40B6664F-4972-11D1-A7CA-0000F87571E3}]
	set ADDINFO2=[{35378EAC-683F-11D2-A89A-00C04FBBCFA2}{0F6B957D-509E-11D1-A7CC-0000F87571E3}]

	if not exist %GPDIR%\%GPT% goto gpt_0
	if exist %GPTDUMMY% del %GPTDUMMY% > nul

	for /F "delims=[] tokens=1,2" %%a in ('find /n /i "[General]" %GPDIR%\%GPT%') do if "%%b" neq "" set gennum=%%a
	if not defined gennum goto gpt_1

	set gptidx=1
:gpttotal
	for /F "skip=%gptidx%" %%a in ('type %GPDIR%\%GPT%') do (
		set /a gptidx=%gptidx%+1
		goto gpttotal
	)

	for /F "delims==: tokens=1,2" %%a in ('findstr /n /b [ %GPDIR%\%GPT%') do (
		if %%a GTR %gennum% (
			set nextnum=%%a
			set nextname=%%b
			goto getnum
		)
	)
:getnum
	if not defined nextname set /a nextnum=%gptidx%+1

	for /F "delims=[]= tokens=1,2,*" %%a in ('find /n "gPCMachineExtensionNames" %GPDIR%\%GPT%') do (
		if "%%b" neq "" (
			if %%a GTR %gennum% (
				set gptinfo=%%a
				goto gptnamechk
			)
		)
	)

	if not defined gptinfo goto gpt_2
:gptnamechk
	if %gptinfo% GTR %nextnum% goto gpt_2

	for /F "delims=[]= tokens=1,2,*" %%a in ('find /n "%ADDINFO1%" %GPDIR%\%GPT%') do (
		if "%%b" equ "gPCMachineExtensionNames" (
			if %%a equ %gptinfo% (
				set add1=%%a
				goto existinfo
			)
		)
	)

	if not defined add1 goto no_info1

:no_info1
	for /F "delims== tokens=1,*" %%a in ('type %GPDIR%\%GPT%') do (
		if /i "%%a" equ "[general]" (
			echo [General]>> %GPTDUMMY%
			goto gpt3_1	
		)
		if /i "%%a" neq "[general]" (
			if "%%b" neq "" (echo %%a=%%b>> %GPTDUMMY%) else echo %%a>> %GPTDUMMY%
		)
	)

:gpt3_1
	call :GPTADDINFO %ADDINFO1% 0
	set gptup=true

:existinfo
	for /F "delims=[]= tokens=1,2,*" %%a in ('find /n "%ADDINFO2%" %GPDIR%\%GPT%') do (
		if "%%b" equ "gPCMachineExtensionNames" (
			if %%a equ %gptinfo% (
				set add2=%%a
				goto gptinfoend
			)
		)
	)

	if not defined add2 goto no_info2

:no_info2
	for /F "delims== tokens=1,*" %%a in ('type %GPDIR%\%GPT%') do (
		if /i "%%a" equ "[general]" (
			echo [General]>> %GPTDUMMY%
			goto gpt_3_2
		)
		if /i "%%a" neq "[general]" (
			if "%%b" neq "" (echo %%a=%%b>> %GPTDUMMY%) else echo %%a>> %GPTDUMMY%
		)
	)

:gpt_3_2
	call :GPTADDINFO %ADDINFO2% 1
	set gptup=true

:gptinfoend
	if defined gptup ( goto verchk ) else (
		call :SETUPLOG add GroupPolicy "Entried gPCMachineExtensionNames was already setting."
		goto verchk
	)

:gpt_0
	echo [General]> %GPTDUMMY%
	echo gPCFunctionalityVersion=2 >> %GPTDUMMY%
	echo gPCMachineExtensionNames=%ADDINFO2%%ADDINFO1%>> %GPTDUMMY%
	echo Version=1 >> %GPTDUMMY%
	copy %GPTDUMMY% %GPDIR%\%GPT% >nul
	del %GPTDUMMY%
	call :SETUPLOG add GroupPolicy "Created new gpt.ini."
	goto Gptupdate

:gpt_1
	type %GPDIR%\%GPT% >> %GPTDUMMY%
	echo [General]>> %GPTDUMMY%
	echo gPCFunctionalityVersion=2 >> %GPTDUMMY%
	echo gPCMachineExtensionNames=%ADDINFO2%%ADDINFO1%>> %GPTDUMMY%
	copy %GPTDUMMY% %GPDIR%\%GPT% >nul
	del %GPTDUMMY%
	call :SETUPLOG add GroupPolicy "Add new gPCMachineExtensionNames."
	goto verchk

:gpt_2
	if %nextnum% GTR %gptidx% (
		type %GPDIR%\%GPT% > %GPTDUMMY%
		echo gPCMachineExtensionNames=%ADDINFO2%%ADDINFO1%>> %GPTDUMMY%
		copy %GPTDUMMY% %GPDIR%\%GPT% >nul
		del %GPTDUMMY%
		goto verchk
	)
	for /F "delims== tokens=1,*" %%a in ('type %GPDIR%\%GPT%') do (
		if "%%a" neq "%nextname%" (
			if "%%b" neq "" (echo %%a=%%b>> %GPTDUMMY%) else echo %%a>> %GPTDUMMY%
		)
		if "%%a" equ "%nextname%" (
			echo gPCMachineExtensionNames=%ADDINFO2%%ADDINFO1%>> %GPTDUMMY%
			echo %nextname%>> %GPTDUMMY%
		)		
	)
	copy %GPTDUMMY% %GPDIR%\%GPT% >nul
	del %GPTDUMMY%
	goto verchk

:verchk

	for /F "delims=[] tokens=1,2" %%a in ('find /n /i "[general]" %GPDIR%\%GPT%') do (
		if "%%b" neq "" set gennum=%%a
	)

	set gptidx=1
:vertotal
	for /F "skip=%gptidx%" %%a in ('type %GPDIR%\%GPT%') do (
		set /a gptidx=%gptidx%+1
		goto vertotal
	)

	for /F "delims==: tokens=1,2" %%a in ('findstr /n /b [ %GPDIR%\%GPT%') do (
		if %%a GTR %gennum% (
			set nextnum=%%a
			set nextname=%%b
			goto vernum
		)
	)
:vernum
	if not defined nextname set /a nextnum=%gptidx%+1

	set version=0
	for /F "delims=[]= tokens=1,2,*" %%a in ('find /n "Version" %GPDIR%\%GPT%') do (
		if %%a GTR %gennum% (
			if %%a LSS %nextnum% (
				if "%%c" neq "" (
					set version=%%c
					set tarnum=%%a
				)
			)
			if %nextnum% GTR %gptidx% (
				if "%%c" neq "" (
					set version=%%c
					set tarnum=%%a
				)
			)
		)
	)
	set /a version=%version%+1
	if not defined tarnum set /a tarnum=%nextnum%-1

	for /F "delims== tokens=*" %%a in ('type %GPDIR%\%GPT%') do (
		echo %%a>> %GPTDUMMY%
		if "%%a" equ "[General]" goto gptver_0
	)

:gptver_0
	if %nextnum% GTR %gptidx% goto gptver_2

:gptver_1
	for /F "skip=%gennum% delims== tokens=1,*" %%a in ('type %GPDIR%\%GPT%') do (
		if "%%a" equ "%nextname%" (
			if %version% leq 1 echo Version=%version% >> %GPTDUMMY%
			goto gptver_1_1
		)
		if "%%a" equ "Version" (
			echo Version=%version% >> %GPTDUMMY%
			goto gptver_1_1
		)
		echo %%a=%%b>> %GPTDUMMY%
	)

:gptver_1_1
	for /F "skip=%tarnum% delims== tokens=*" %%a in ('type %GPDIR%\%GPT%') do (
		echo %%a>> %GPTDUMMY%
	)
	goto gptverend

:gptver_2
	for /F "skip=%gennum% delims== tokens=1,*" %%a in ('type %GPDIR%\%GPT%') do (
		if "%%a" neq "Version" (
			if "%%b" neq "" (echo %%a=%%b>> %GPTDUMMY%) else echo %%a>> %GPTDUMMY%
		)
	)
	echo Version=%version% >> %GPTDUMMY%
	goto gptverend

:gptverend
	copy %GPTDUMMY% %GPDIR%\%GPT% >nul
	del %GPTDUMMY%
	call :SETUPLOG add GroupPolicy "gpt.ini was update. Version=%version%"


REM ********** O[v|V[̍XV ****

:Gptupdate
	gpupdate /Target:Computer


REM ********** WXg̊mF **********
:GPTCHK

	set analyze=%setidx%

:numanalyze
	set /a num16=%analyze% %% 16
	set /a analyze=%analyze% / 16

	if %num16% equ 10 set num16=a
	if %num16% equ 11 set num16=b
	if %num16% equ 12 set num16=c
	if %num16% equ 13 set num16=d
	if %num16% equ 14 set num16=e
	if %num16% equ 15 set num16=f

	set scregnum=%num16%%scregnum%
	if %analyze% gtr 0 goto numanalyze

	set regpath1=HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Group Policy\State\Machine\Scripts\Shutdown\0\%scregnum%
	set regpath2=HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\policies\system

	set scriptstate=0
	set paramstate=0
	set gpowaitstate=0

:cmdchk
	for /F "tokens=1-3" %%a in ('reg query "%regpath1%" ^| findstr /i Script') do (
		if "%%c" equ "" ( set cmdline= ) else set cmdline=%%c
	)
	if not defined cmdline (
		set scriptstate=1
		goto paramchk
	)
	set scriptstate=2
	if /i "%cmdline%" equ "cscript" set scriptstate=0
	if /i "%cmdline%" equ "cscript.exe" set scriptstate=0

:paramchk
	for /F "tokens=1-4" %%a in ('reg query "%regpath1%" ^| findstr /i "CalRev.wsf"') do (
		if /i "%%d" equ "//job:shutdown" set params=%%a
	)
	if not defined params (
		set paramstate=1
		goto gpowaitchk
	)
	if "%params%" neq "Parameters" set paramstate=2

:gpowaitchk
	set cmdline=
	for /F "tokens=1-3" %%a in ('reg query "%regpath2%" ^| findstr MaxGPOScriptWait') do (
		if "%%a" equ "MaxGPOScriptWait" (
			if "%%c" equ "" ( set cmdline= ) else set cmdline=%%c
		)
	)
	if not defined cmdline (
		set gpowaitstate=1
		goto result
	)
	if %cmdline% LSS %Data% set gpowaitstate=2

:result
	if %scriptstate% lss 1 (
		echo %regpath1%\Script data is correct.
		call :SETUPLOG add Result "%regpath1%\Script data is correct."
	)
	if %scriptstate% equ 1 (
		echo %regpath1%\Script not exist.
		call :SETUPLOG add Result "%regpath1%\Script not exist."
	)
	if %scriptstate% equ 2 (
		echo %regpath1%\Script data is incorrect.
		call :SETUPLOG add Result "%regpath1%\Script data is incorrect."
	)
	if %paramstate% lss 1 (
		echo %regpath1%\Parameters data is correct.
		call :SETUPLOG add Result "%regpath1%\Parameters data is correct."
	)
	if %paramstate% equ 1 (
		echo %regpath1%\Parameters not exist.
		call :SETUPLOG add Result "%regpath1%\Parameters not exist."
	)
	if %paramstate% equ 2 (
		echo %regpath1%\Parameters data is incorrect.
		call :SETUPLOG add Result "%regpath1%\Parameters data is incorrect."
	)
	if %gpowaitstate% lss 1 (
		echo %regpath2%\MaxGPOScriptWait data is correct.
		call :SETUPLOG add Result "%regpath2%\MaxGPOScriptWait data is correct."
	)
	if %gpowaitstate% equ 1 (
		%regpath2%\MaxGPOScriptWait not exist.
		call :SETUPLOG add Result "%regpath2%\MaxGPOScriptWait not exist."
	)
	if %gpowaitstate% equ 2 (
		echo %regpath2%\MaxGPOScriptWait data is incorrect.
		call :SETUPLOG add Result "%regpath2%\MaxGPOScriptWait data is incorrect."
	)

	if %scriptstate% GTR 0 (
		call :E_GROUPPOLICY
		goto End
	)
	if %paramstate% GTR 0 (
		call :E_GROUPPOLICY
		goto End
	)
	if %gpowaitstate% GTR 0 (
		call :E_GROUPPOLICY
		goto End
	)
	call :SETUPLOG add Result "Setting of Group Policy is correct."

REM **************************************************
REM CabinetpbP[WWJ
REM **************************************************
:EXPAND
	expand -r %SETUPCAB% -f:*.* %SETUPDIR%
	if %errorlevel% neq 0 (
		call :E_EXPAND %SETUPCAB% %SETUPDIR%
		goto END
	)

REM **************************************************
REM ^XNXPW[֓o^
REM **************************************************
:WINTASKS
	set TASKNAME1=CalRev_Revise
	set TASKNAME2=CalRev_Sync
	set TASKNAME3=CalRev_Sysboot

	move /y %SETUPDIR%\*.job %TASKSDIR%
	if %errorlevel% neq 0 (
		call :E_COPY %SETUPDIR%\*.job %TASKSDIR%
		goto END
	)

	attrib +h %TASKSDIR%\%TASKNAME1%.job
	attrib +h %TASKSDIR%\%TASKNAME2%.job
	attrib +h %TASKSDIR%\%TASKNAME3%.job

	schtasks /change /tn %TASKNAME1% /ru system /tr "%MySystemRoot%\System32\cscript.exe %SETUPDIR%\%COREFILE%"
	if %errorlevel% neq 0 (
		call :E_SCHTASKS
		goto END
	)
	schtasks /change /tn %TASKNAME2% /ru system /tr "%MySystemRoot%\System32\cscript.exe %SETUPDIR%\%COREFILE% /I"
	if %errorlevel% neq 0 (
		call :E_SCHTASKS
		goto END
	)
	schtasks /change /tn %TASKNAME3% /ru system /tr "%MySystemRoot%\System32\cscript.exe %SETUPDIR%\%COREFILE% /S"
	if %errorlevel% neq 0 (
		call :E_SCHTASKS
		goto END
	)

call :EVENTLOG_I 10 "Setup was successful."
call :SETUPLOG add Result "Setup was successful."
echo.
echo Setup was successful.
echo.
goto END

REM @@@@@@@@@@ THE END OF SETUP JOB @@@@@@@@@@

REM ++++++++++++++++++++++++++++++++++++++++++++++++++
REM 2010/08/16 add Handler
REM ++++++++++++++++++++++++++++++++++++++++++++++++++

REM --------------------------------------------------
REM T[rX̋NԊmF
REM --------------------------------------------------
:SERCHK

	for /F "delims=: tokens=1,2" %%a in ('sc qc %SCHEDULENAME% ^| findstr AUTO') do set IsSCHSTART=%%b
	if not defined IsSCHSTART set /a COUNT=%COUNT% + 16

	for /F "tokens=1,2 delims=: " %%a in ('sc query %SCHEDULENAME% ^| findstr RUNNING') do set IsSCHRUN=%%b
	if not defined IsSCHRUN (
		set /a COUNT=%COUNT% + 8
		for /F "tokens=1,2,3 delims=: " %%a in ('sc query schedule ^| findstr STATE') do set IsSCHRUN=%%b
	)

	for /F "delims=: tokens=1,2" %%a in ('sc qc %WINMGMTNAME% ^| findstr AUTO') do set IsWINMGSTART=%%b
	if not defined IsWINMGSTART set /a COUNT=%COUNT% + 4

	for /F "tokens=1,2,3 delims=: " %%a in ('sc query %WINMGMTNAME% ^| findstr PAUSED') do set IsWINPAUSED=%%b
	if defined IsWINPAUSED set /a COUNT=%COUNT% + 2

	goto :EOF

REM --------------------------------------------------
REM script.ini֏ǉ
REM %1: XNvgo^ԍ
REM %2: Zop[^l
REM     Zol: (boot loader timeout) + 600
REM --------------------------------------------------
:SCRIPTUPDATE
	set CMD=CmdLine=cscript
	set PARAM=Parameters=CalRev.wsf //job:shutdown

	echo %1%CMD%>> %SCDUMMY%
	if "%2" equ "" echo %1%PARAM%>> %SCDUMMY%
	if "%2" neq "" echo %1%PARAM% /T:%2>> %SCDUMMY%
	goto :EOF

REM --------------------------------------------------
REM O[v|V[̒ǉo^
REM %1: ǉ
REM %2: ǉ̉ӏw
REM	0:ɒǉ
REM	1:擪ɒǉ
REM --------------------------------------------------
:GPTADDINFO
	for /F "skip=%gennum% tokens=1,2,3 delims== " %%a in ('type %GPDIR%\%GPT%') do (
		if "%%a" equ "gPCMachineExtensionNames" (
			if %2 GTR 0 (echo %%a=%1%%b>> %GPTDUMMY%) else echo %%a=%%b%1>> %GPTDUMMY%
		)
		if "%%a" neq "gPCMachineExtensionNames" (
			if "%%b" equ "" (echo %%a>>%GPTDUMMY%) else echo %%a=%%b>> %GPTDUMMY%
		)
		if %nextnum% LEQ %gptidx% (
			if "%%a" equ "%nextname%" goto gptaddinfo_1
		)
	)
	copy %GPTDUMMY% %GPDIR%\%GPT% >nul
	del %GPTDUMMY%
	goto :EOF

:gptaddinfo_1
	for /F "skip=%nextnum% delims== tokens=*" %%a in ('type %GPDIR%\%GPT%') do (
		echo %%a>> %GPTDUMMY%
	)
	copy %GPTDUMMY% %GPDIR%\%GPT% >nul
	del %GPTDUMMY%
	goto :EOF

REM --------------------------------------------------
REM Ot@C̒ǋL/㏑
REM %1: add      ǋL
REM     create   ㏑
REM %2: LABEL
REM %3: Massage
REM --------------------------------------------------
:SETUPLOG
	set HOUR=%TIME:~0,2%
	set MINUTE=%TIME:~3,2%
	set SECOND=%TIME:~6,2%

	set FTIME=%HOUR%:%MINUTE%:%SECOND%

	if "%1" equ "add" (
		if not exist "%RTCDIR%" mkdir "%RTCDIR%"
		echo %DATE% %FTIME% :%2 - %3>>"%RTCDIR%\RTCSetup.log"
	)

	if "%1" equ "create" (
		echo %DATE% %FTIME% :%2 - %3>"%RTCDIR%\RTCSetup.log"
	)

	goto :EOF

REM --------------------------------------------------
REM XNvgԍ̎擾
REM %1: String of parameters
REM --------------------------------------------------
:GETSCRIPTNUM

	set cmpnum=%1
:loop_2
	if %cmpnum:~0,1% LEQ 9 (
		set tmpnum=%tmpnum%%cmpnum:~0,1%
		set cmpnum=%cmpnum:~1%
		goto loop_2
	)

	set setidx=%tmpnum%
	goto :EOF

REM --------------------------------------------------
REM setgpw.exeerrorlevel̃`FbN
REM %1: String of parameters
REM --------------------------------------------------
:EDIT_REGISTRY

	setgpw.exe %1
	set addmsg= So please refer to the installation manual and set MaxGPOScriptWait parameter to %1 with Group Policy Editor.

	if %Errorlevel% equ 1 (
		call :EVENTLOG_E 50 "setgpw.exe failed to allocate memory. %addmsg% [setgpw.exe:1]"
		call :SETUPLOG add EDIT_REGISTRY "setgpw.exe failed to allocate memory. %addmsg% [err: %errorlevel%]"
		echo.
		echo setgpw.exe failed to allocate memory.
		echo %addmsg% [setgpw.exe:1]
		echo.
		set iserror=1
	)
	if %Errorlevel% equ 2 (
		call :EVENTLOG_E 50 "setgpw.exe failed to find file. %addmsg% [setgpw.exe:2]"
		call :SETUPLOG add EDIT_REGISTRY "setgpw.exe failed to find file. %addmsg% [err: %errorlevel%]"
		echo.
		echo setgpw.exe failed to find file.
		echo %addmsg% [setgpw.exe:2]
		echo.
		set iserror=1
	)
	if %Errorlevel% equ 3 (
		call :EVENTLOG_E 50 "setgpw.exe failed to find path. %addmsg% [setgpw.exe:3]"
		call :SETUPLOG add EDIT_REGISTRY "setgpw.exe failed to find path. %addmsg% [err: %errorlevel%]"
		echo.
		echo setgpw.exe failed to find path.
		echo %addmsg% [setgpw.exe:3]
		echo.
		set iserror=1
	)
	if %Errorlevel% equ 4 (
		call :EVENTLOG_E 50 "setgpw.exe failed to open Registry.pol. %addmsg% [setgpw.exe:4]"
		call :SETUPLOG add EDIT_REGISTRY "setgpw.exe failed to open Registry.pol. %addmsg% [err: %errorlevel%]"
		echo.
		echo setgpw.exe failed to open Registry.pol.
		echo %addmsg% [setgpw.exe:4]
		echo.
		set iserror=1
	)
	if %Errorlevel% equ 5 (
		call :EVENTLOG_E 50 "setgpw.exe failed to read Registry.pol. %addmsg% [setgpw.exe:5]"
		call :SETUPLOG add EDIT_REGISTRY "setgpw.exe failed to read Registry.pol. %addmsg% [err: %errorlevel%]"
		echo.
		echo setgpw.exe failed to read Registry.pol.
		echo %addmsg% [setgpw.exe:5]
		echo.
		set iserror=1
	)
	if %Errorlevel% equ 6 (
		call :EVENTLOG_E 50 "setgpw.exe failed to update Registry.pol. %addmsg% [setgpw.exe:6]"
		call :SETUPLOG add EDIT_REGISTRY "setgpw.exe failed to update Registry.pol. %addmsg% [err: %errorlevel%]"
		echo.
		echo setgpw.exe failed to update Registry.pol.
		echo %addmsg% [setgpw.exe:6]
		echo.
		set iserror=1
	)
	if %Errorlevel% equ 7 (
		call :EVENTLOG_E 50 "setgpw.exe failed to open tmp_file. %addmsg% [setgpw.exe:7]"
		call :SETUPLOG add EDIT_REGISTRY "setgpw.exe failed to open tmp_file. %addmsg% [err: %errorlevel%]"
		echo.
		echo setgpw.exe failed to open tmp_file.
		echo %addmsg% [setgpw.exe:7]
		echo.
		set iserror=1
	)
	if %Errorlevel% equ 8 (
		call :EVENTLOG_E 50 "setgpw.exe failed to write file. %addmsg% [setgpw.exe:8]"
		call :SETUPLOG add EDIT_REGISTRY "setgpw.exe failed to write tmp_file. %addmsg% [err: %errorlevel%]"
		echo.
		echo setgpw.exe failed to write file.
		echo %addmsg% [setgpw.exe:8]
		echo.
		set iserror=1
	)
	if %Errorlevel% equ 9 (
		call :EVENTLOG_E 50 "setgpw.exe failed to Read file. %addmsg% [setgpw.exe:9]"
		call :SETUPLOG add EDIT_REGISTRY "setgpw.exe failed to Read tmp_file. %addmsg% [err: %errorlevel%]"
		echo.
		echo setgpw.exe failed to Read file.
		echo %addmsg% [setgpw.exe:9]
		echo.
		set iserror=1
	)
	if %Errorlevel% equ 10 (
		call :EVENTLOG_E 50 "SETUP.BAT failed to edit MaxGPOScriptWait parameter in Registry.pol file since Registry.pol contained unsupported entries. %addmsg% [setgpw.exe:10]"
		call :SETUPLOG add EDIT_REGISTRY "SETUP.BAT failed to edit MaxGPOScriptWait parameter in Registry.pol file since Registry.pol contained unsupported entries. %addmsg% [err: %errorlevel%]"
		echo.
		echo SETUP.BAT failed to edit MaxGPOScriptWait parameter in Registry.pol file since Registry.pol contained unsupported entries.
		echo %addmsg% [setgpw.exe:10]
		echo.
		set iserror=1
	)

	goto :EOF

REM ++ 2010/08/16 Add End ++++++++++++++++++++++++++++

REM ++++++++++++++++++++++++++++++++++++++++++++++++++
REM G[nh
REM ++++++++++++++++++++++++++++++++++++++++++++++++++
REM --------------------------------------------------
REM CxgO֋L^
REM %1: ID
REM     10`F^30`Fx^50`FG[
REM %2: Description
REM --------------------------------------------------
:EVENTLOG_E
	eventcreate /l SYSTEM /so CalRev /t ERROR /id %1 /d %2 > nul
	goto :EOF

:EVENTLOG_I
	eventcreate /l SYSTEM /so CalRev /t INFORMATION /id %1 /d %2 > nul
	goto :EOF

REM --------------------------------------------------
REM LrlbgWJG[
REM %1: CABt@C
REM %2: WJ
REM --------------------------------------------------
:E_EXPAND
	set EXIT_CODE=1
	echo.>&2
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!>&2
	echo Unable to expand. [err: %errorlevel%]>&2
	echo -- File: %1.>&2
	echo -- Expand to: %2.>&2
	echo ERROR_CODE:%EXIT_CODE%
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!>&2
	echo.>&2
	call :EVENTLOG_E 50 "Setup was failed. [%EXIT_CODE%]"
	call :SETUPLOG add E_EXPAND "ERR:%EXIT_CODE% Unable to expand. [err: %errorlevel%]"
	goto :EOF

REM --------------------------------------------------
REM t@C(tH_)݂Ȃ
REM %1: t@C(tH_)
REM --------------------------------------------------
:E_NOT_FOUND
	set EXIT_CODE=2
	echo.>&2
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!>&2
	echo File(Folder) is not found. [err: %errorlevel%]>&2
	echo -- File(Folder): %1.>&2
	echo ERROR_CODE:%EXIT_CODE%
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!>&2
	echo.>&2
	call :EVENTLOG_E 50 "Setup was failed. [%EXIT_CODE%]"
	call add E_NOT_FOUND "ERR:%EXIT_CODE% File(Folder) is not found. [err: %errorlevel%]"
	goto :EOF

REM --------------------------------------------------
REM t@C̃Rs[(ړ)G[
REM %1: Rs[t@C
REM %2: Rs[
REM --------------------------------------------------
:E_COPY
	set EXIT_CODE=3
	echo.>&2
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!>&2
	echo Failed to copy(move). [err: %errorlevel%]>&2
	echo -- File: %1.>&2
	echo -- Copy(Move) to: %2.>&2
	echo ERROR_CODE:%EXIT_CODE%
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!>&2
	echo.>&2
	call :EVENTLOG_E 50 "Setup was failed. [%EXIT_CODE%]"
	call :SETUPLOG add E_COPY "ERR:%EXIT_CODE% Failed to copy(move). [err: %errorlevel%]"
	goto :EOF

REM --------------------------------------------------
REM 2010/08/16 ^XNXPW[ւ̒ǉG[
REM --------------------------------------------------
:E_SCHTASKS
	set EXIT_CODE=4
	echo.>&2
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!>&2
	echo Failed to schedule task. [err: %errorlevel%]>&2
	echo ERROR_CODE:%EXIT_CODE%
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!>&2
	echo.>&2
	call :EVENTLOG_E 50 "Setup was failed. [%EXIT_CODE%]"
	call :SETUPLOG add E_SCHTASKS "ERR:%EXIT_CODE% Failed to schedule task. [err: %errorlevel%]"
	goto :EOF

REM --------------------------------------------------
REM 2010/08/16 mmc.exeN
REM --------------------------------------------------
:E_GPOEDIT

	set EXIT_CODE=5

	for /F "delims=, tokens=10" %%a in ('tasklist /v /fo CSV ^| findstr mmc.exe ') do (
		set winname=%%a
	)
	echo.>&2
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!>&2
	echo Can not install script because of running %winname%. >&2
	echo Please close %winname% and run SETUP.BAT again.>&2
	echo ERROR_CODE:%EXIT_CODE% >&2
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!>&2

	call :EVENTLOG_E 50 "Setup was failed. [%EXIT_CODE%]"
	call :SETUPLOG add E_GPOEDIT "ERR:%EXIT_CODE% Install stopped to run %winname%."
	goto :EOF


REM --------------------------------------------------
REM 2010/08/16 T[rX݂Ȃ
REM --------------------------------------------------
:E_ISSERV
	set EXIT_CODE=6
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!>&2
	echo Failed to change services. Following services are not installed. >&2
	echo        -Task Scheduler >&2
	echo        -Windows Management Instrumentation >&2
	echo ERROR_CODE:%EXIT_CODE% >&2
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!>&2

	call :EVENTLOG_E 50 "Setup was failed. [%EXIT_CODE%]"
	call :SETUPLOG add SERVCONF "ERR:%EXIT_COIDE% %1 does not exist."
	goto :EOF

REM --------------------------------------------------
REM 2010/08/16 T[rXύXmF
REM --------------------------------------------------
:E_SERVCONF
	set EXIT_CODE=7
	echo.>&2
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!>&2
	echo Installation aborted.
	echo These services are required for Calendar revise patch.>&2
	echo ERROR_CODE:%EXIT_CODE%
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!>&2
	
	call :EVENTLOG_E 50 "Setup was failed. [%EXIT_CODE%]"
	call :SETUPLOG add E_SERVCONF "ERR:%EXIT_CODE% Setting of the Services was failed."
	goto :EOF

REM --------------------------------------------------
REM 2010/08/16 T[rXύXG[
REM --------------------------------------------------
:E_SERCHK
	set EXIT_CODE=8
	echo.>&2
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!>&2
	echo Failed setting Task Scheduler or Windows Management Instrumentation.>&2
	echo ERROR_CODE:%EXIT_CODE%
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!>&2

	call :EVENTLOG_E 50 "Setup was failed. [%EXIT_CODE%]"
	call :SETUPLOG add E_SERCHK "ERR:%EXIT_CODE% Failed setting Task Scheduler or Windows Management Instrumentation."
	goto :EOF

REM --------------------------------------------------
REM 2010/08/16 O[v|V[̓o^G[
REM --------------------------------------------------
:E_GROUPPOLICY
	set EXIT_CODE=9
	echo.>&2
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!>&2
	echo Failed to entry Group Policy.>&2
	echo ERROR_CODE:%EXIT_CODE%
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!>&2

	call :EVENTLOG_E 50 "Setup was failed. [%EXIT_CODE%]"
	call :SETUPLOG add E_GROUPPOLICY "ERR:%EXIT_CODE% ShutdownScript entry failed."
	goto :EOF

REM **************************************************
REM END of SETUP
REM **************************************************

:END
	if %isSilent% equ 0 set /p choice=Installer is done. Command prompt closes by input key. 

popd
endlocal
echo on
@exit /b %EXIT_CODE%

